float ch;
unsigned int ADC_Value;
long tlong;
/*................................................. ...............................
 Define relay selection port pins
.................................................. ...............................*/
sbit RL1 at RA1_bit;
sbit RL2 at RC0_bit;
sbit RL3 at RC1_bit;
sbit RL4 at RC2_bit;
sbit RL5 at RA2_bit;
//defined RL1 at PORTA,1;//PIN 12
//sbit RL2 at RC0_bit;//PIN 10
//sbit RL3 at RC1_bit;//PIN 09
//sbit RL4 at RC2_bit;//PIN 08
//sbit RL5 at PORTA,2;//PIN 11
/*................................................. ...............................
 Define LED/ bzr selection port pins
.................................................. ...............................*/
sbit L1  at  Rc5_bit;//PIN 05 hi\lo cut
sbit L2  at  Rc4_bit;//PIN 06 mains normal
sbit BZR at  Rc3_bit;//PIN 07 SOUND

/*................................................. ...............................
 Define LED/ bzr selection port pins
.................................................. ...............................*/

sbit SW1 at  RA5_bit;//PIN 03 hi\lo cut enabol
sbit SW2 at  RA4_bit;//PIN 02 QEK SATART


void main()
{
//ANSEL = 0x01;  // RA0 analog input
    TRISA = 0x39; // setting RA0 analog input & RA3 -RA5 digital i\p
    TRISC = 0x00; // setting port C as output.
    // Configure ADCON0 for channel AN0
    ADCON0=0x01;
    ADCON1=0x00;


loop_01:

    L2 = 1;// mains normal on
    L1 = 0;// hi\lo cut off
    BZR = 0;// SOUND off
    RL4 = 0;// Output relay off R4

    /*................................................. ...............................
    Delay mode selection for user friendly...
    .................................................. ...............................*/

    if(SW2 == 0)
    {
        Delay_ms(5);
    }
    else
    {
        Delay_ms(1);
    }

    /* .................................................. .............................
    Main working starts here
    .................................................. ................................*/
    L1 = 0; // delay indicator off.
    while(1)
    {
        ADC_Value = ADC_Read(0); // A/D conversion. Pin RA2 is an input.
        tlong =(long)ADC_Value*5000; // Convert the result in millivolts
        tlong = tlong/1023; // 0..1023 -> 0-5000mV
        ch =(float)tlong/1000; // Extract volts (thousands of millivolts)

        /*................................................. ...............................
        Main stabilizing is done here
        .................................................. ...............................*/

        if((ch<=4.60)&&(ch>=1.40))
        {

            if(ch>4.65)
            {
                if(ch>4.00)
                {
                    if(ch>3.65)
                    {
                        if(ch>3.15)
                        {
                            if(ch>2.56)
                            {
                                if(ch>1.48)
                                {
                                    //if(ch>1.40)
                                    //{
                                    RL5 = 1;
                                    RL3 = 1;
                                    RL2 = 1;
                                    RL1 = 0;//STP7
                                }
                                //else
                                RL5 = 1;
                                RL2 = 1;
                                RL1 = 0;
                                RL3 = 0;//STP6
                            }
                            //else
                            RL3 = 1;
                            RL2 = 1;
                            RL1 = 0;
                            RL5 = 0;//STP5
                        }
                        //else
                        RL2 = 1;
                        RL1 = 0;
                        RL5 = 0;
                        RL3 = 0;//STP4
                    }
                    //else
                    RL3 = 1;
                    RL1 = 0;
                    RL5 = 0;
                    RL2 = 0;//STP3
                }
                //else
                RL1 = 0;
                RL3 = 1;
                RL5 = 0;
                RL2 = 0;//STP2
            }
            //else
            RL3 = 1;
            RL1 = 0;
            RL5 = 0;
            RL2 = 0;//STP1
        }
        //else
        RL5 = 1;
        RL3 = 1;
        RL2 = 1;
        RL1 = 0;

        RL4 = 1;// output relay on.
        L2 = 1; // mains indicator on
        L1 = 0; // high //low voltage indicator off
        BZR = 0; // high //low voltage indicator off

    }

    /*................................................. ...............................
    High voltage protection for load is done here
    .................................................. ...............................*/

    if(ch > 4.80)
    {
        L1 = 1; // high // low voltage indicator on
        BZR = 1; // cret sound
        RL4 = 0; // relay off
        L2 = 0; // Mains normal indicator off
        goto loop_01;
    }
    /*................................................. ...............................
    Low voltage protection is done here
    .................................................. ...............................*/

    if(ch <= 1.30)
    {
        L1 = 1; // high // low voltage indicator on
        BZR = 1; // cret sound
        RL4 = 0; // relay off
        L2 = 0; // Mains normal indicator off
        goto loop_01;
    }

}  // End main()